#include <stdio.h>
#include <math.h>

#include "complex.h"

complex complex_new(double re, double im)
{
  complex c;

  c.re_ = re;
  c.im_ = im;

  return c;
}

void complex_disp(complex c)
{
  if (c.im_ == 0)
    printf("%f\n", c.re_);
  else if (c.re_ == 0)
    {
      if (c.im_ < 0)
	printf("-i%f\n", -c.im_);
      else
	printf("i%f\n", c.im_);
    }
  else
    {
      if (c.im_ < 0)
	printf("%f-i%f\n", c.re_, -c.im_);
      else
	printf("%f+i%f\n", c.re_, c.im_);
    }
}

complex complex_add(complex c1, complex c2)
{
  complex c;

  c.re_ = c1.re_ + c2.re_;
  c.im_ = c1.im_ + c2.im_;

  return c;
}

complex complex_sub(complex c1, complex c2)
{
  complex c;

  c.re_ = c1.re_ - c2.re_;
  c.im_ = c1.im_ - c2.im_;

  return c;
}

complex complex_mul(complex c1, complex c2)
{
  complex c;

  c.re_ = c1.re_ * c2.re_ - c1.im_ * c2.im_;
  c.im_ = c1.re_ * c2.im_ + c1.im_ * c2.re_;

  return c;
}

complex complex_div(complex c1, complex c2)
{
  complex c;
  double m;

  if (complex_mod(c2) == 0.0)
    printf("division by 0\n");

  m = complex_mod_square(c2);
  c = complex_mul(c1, complex_conj(c2));

  c.re_ /= m;
  c.im_ /= m;

  return c;
}

complex complex_conj(complex c)
{
  complex r;

  r.re_ = c.re_;
  r.im_ = -c.im_;

  return r;
}

double complex_mod_square(complex c)
{

  return c.re_ * c.re_ + c.im_ * c.im_;
}

double complex_mod(complex c)
{

  return sqrt(complex_mod_square(c));
}
